【LeetCode】357. Count Numbers with Unique Digits

357. Count Numbers with Unique Digits
Given a non-negative integer n, count all numbers with unique digits, x, where 0 ≤ x < 10n.
Example:
Given n = 2, return 91. (The answer should be the total numbers in the range of 0 ≤ x < 100, excluding [11,22,33,44,55,66,77,88,99])

Hint:
    1. A direct way is to use the backtracking approach.
    2. Backtracking should contains three states which are (the current number, number of steps to get that number and a bitmask which represent which number is marked as visited so far in the current number). Start with state (0,0,0) and count all valid number till we reach number of steps equals to 10n.
    3. This problem can also be solved using a dynamic programming approach and some knowledge of combinatorics.
    4. Let f(k) = count of numbers with unique digits with length equals k.
    5. f(1) = 10, ..., f(k) = 9 * 9 * 8 * ... (9 - k + 2) [The first factor is 9 because a number cannot start with 0].
Credits:
Special thanks to @memoryless for adding this problem and creating all test cases.

【解題思路】
dp和遞歸都可以解決。
假設f(k)代表位數爲k時所求結果。那麼f(1) = 10,f(2) = 9 * 8 (十位可以取1,2,3,4,5,6,7,8,9一共九個數,個位可選擇就是8+1 多個0),
以此類推,f(3) = 9 * 9 * 8
f(k) = 9 * 9 * 8 * (11 - k)
dp[k]爲所求結果,則dp[k] = f[k] + f[k-1] + ... + f[1]

注意11位時候一定有重複,所以11及以上數字和10一樣。

Java AC
public class Solution {
    public int countNumbersWithUniqueDigits(int n) {
        if(n == 0){
            return 1;
        }
        if(n == 1){
            return 10;
        }
        n = n > 10 ? 10 : n;
        int f[] = new int[n + 1];
        f[1] = 10;
        f[2] = 9 * 9;
        for(int i = 3; i < n + 1; i++){
            f[i] = f[i - 1] * (11 - i);
        }
        int dp[] = new int[n + 1];
        dp[1] = 10;
        for(int i = 2; i < n + 1; i++){
            dp[i] = dp[i - 1] + f[i];
        }
        return dp[n];
    }
}


發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章